<?xml version="1.0" encoding="utf-8"?>
<!--
/*
 * Copyright (C) 2007-2008 Esmertec AG.
 * Copyright (C) 2007-2008 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
-->
<manifest xmlns:android="http://schemas.android.com/apk/res/android"
        package="com.android.mms" android:sharedUserId="android.uid.mms">

    <original-package android:name="com.android.mms" />

    <uses-permission android:name="android.permission.RECEIVE_BOOT_COMPLETED" />
    <uses-permission android:name="android.permission.CALL_PHONE" />
    <uses-permission android:name="android.permission.READ_CONTACTS" />
    <uses-permission android:name="android.permission.WRITE_CONTACTS" />
    <uses-permission android:name="android.permission.READ_PROFILE" />
    <uses-permission android:name="android.permission.RECEIVE_SMS" />
    <uses-permission android:name="android.permission.RECEIVE_EMERGENCY_BROADCAST" />
    <uses-permission android:name="android.permission.RECEIVE_CB_SMS" />
    <uses-permission android:name="android.permission.RECEIVE_MMS" />
    <uses-permission android:name="android.permission.SEND_SMS" />
    <uses-permission android:name="android.permission.VIBRATE" />
    <uses-permission android:name="android.permission.INTERNET" />
    <uses-permission android:name="android.permission.READ_SMS"/>
    <uses-permission android:name="android.permission.WRITE_SMS"/>
    <uses-permission android:name="android.permission.ACCESS_NETWORK_STATE" />
    <uses-permission android:name="android.permission.CHANGE_NETWORK_STATE" />
    <uses-permission android:name="android.permission.READ_PHONE_STATE" />
    <uses-permission android:name="android.permission.WAKE_LOCK" />
    <uses-permission android:name="android.permission.WRITE_EXTERNAL_STORAGE" />
    <uses-permission android:name="android.permission.INSTALL_DRM" />

    <uses-permission android:name="android.permission.READ_WAPPUSH" />
    <uses-permission android:name="android.permission.WRITE_WAPPUSH" />
    <uses-permission android:name="android.permission.RECEIVE_WAP_PUSH" />
    <uses-permission android:name="android.permission.WRITE_SETTINGS"/>
    <uses-permission android:name="android.permission.WRITE_SECURE_SETTINGS"/>
    <!-- Dialog mode-->
    <uses-permission android:name="android.permission.GET_TASKS" />

    <application android:name="MmsApp"
            android:label="@string/app_label"
            android:icon="@mipmap/ic_launcher_smsmms"
            android:taskAffinity="android.task.mms"
            android:allowTaskReparenting="true">
        <service android:name=".transaction.TransactionService"
                 android:exported="true" />

        <service android:name=".transaction.SmsReceiverService"
                 android:exported="true" />

        <service android:name=".transaction.WapPushReceiverService"
                 android:exported="true" />

        <service android:name=".transaction.CBMessageReceiverService"
                 android:exported="true" />

        <service android:name=".util.OMACPReceiverService"
                 android:exported="true" /> 
        <activity android:name=".ui.BootActivity"
                  android:theme="@android:style/Theme.NoDisplay">
            <intent-filter>
                <action android:name="android.intent.action.MAIN" />
                <category android:name="android.intent.category.LAUNCHER" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.MAIN" />
                <category android:name="android.intent.category.DEFAULT" />
                <data android:mimeType="vnd.android.cursor.dir/mms" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.MAIN" />
                <category android:name="android.intent.category.DEFAULT" />
                <data android:mimeType="vnd.android-dir/mms-sms" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.MAIN" />
                <category android:name="android.intent.category.DEFAULT" />
                <data android:mimeType="vnd.android.cursor.dir/cb-messages" />
            </intent-filter>
        </activity>
        <activity android:name=".ui.ConversationList"
                  android:label="@string/app_label"
                  android:exported="true"
                  android:configChanges="orientation|screenSize|keyboardHidden"
                  android:theme="@style/MmsHoloTheme"
                  android:uiOptions="splitActionBarWhenNarrow"
                  android:launchMode="singleTop">
        </activity>

        <!-- Dialog mode android:theme="@style/Theme.SmsDlgScreen"-->
        <activity
            android:name=".ui.DialogModeActivity"
            android:taskAffinity="android.task.mms_dialog"
            android:launchMode="singleInstance"
            android:theme="@style/Theme.SmsDlgScreen"
            android:excludeFromRecents="true"
            >
            <intent-filter>
            </intent-filter>
        </activity>

        <!-- FolderMode -->
        <activity android:name=".ui.FolderViewList"
                  android:configChanges="orientation|screenSize|keyboardHidden"
                  android:theme="@style/MmsHoloTheme"
                  android:uiOptions="splitActionBarWhenNarrow"
                  android:launchMode="singleTop">
        </activity>
        
        <activity android:name=".ui.SiminfoSelectedActivity"
                  android:configChanges="orientation|screenSize|keyboardHidden"
                  android:theme="@android:style/Theme.Dialog">
        </activity>
        


        <activity android:name=".ui.MultiSaveActivity"
                  android:configChanges="orientation|keyboardHidden">        
        </activity>

        <activity android:name=".ui.PreviewActivity"
                  android:configChanges="orientation|keyboardHidden">        
        </activity>
        <activity android:name=".ui.FolderModeSmsViewer"
            android:label="@string/text_message"
            android:theme="@style/MmsHoloTheme"
            android:configChanges="orientation|screenSize|keyboardHidden" >
        </activity>
        <activity android:name=".ui.CBMessageListActivity"
                  android:configChanges="orientation|screenSize|keyboardHidden"
                  android:launchMode="singleTop">
            <intent-filter>
                <action android:name="android.intent.action.VIEW" />
                <category android:name="android.intent.category.DEFAULT" />
                <data android:mimeType="vnd.android.cursor.dir/cb-messages" />
            </intent-filter>
        </activity>

        <!-- wap push begin -->
        <!-- WPMessageActivity, the launcherMode is same with ComposeMessageActivity -->         
        <activity android:name=".ui.WPMessageActivity"
                  android:theme="@style/MmsHoloTheme"
                  android:configChanges="orientation|keyboardHidden"
                  android:launchMode="singleTop" >
        </activity>
        
         <!-- wap push end -->

        <activity android:name=".ui.ComposeMessageActivity"
                  android:configChanges="orientation|screenSize|keyboardHidden|mcc|mnc"
                  android:windowSoftInputMode="stateHidden"
                  android:theme="@style/MmsHoloTheme"
                  android:launchMode="singleTop" >
            <intent-filter>
                <action android:name="android.intent.action.VIEW" />
                <category android:name="android.intent.category.DEFAULT" />
                <data android:mimeType="vnd.android-dir/mms-sms" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.VIEW" />
                <action android:name="android.intent.action.SENDTO" />
                <category android:name="android.intent.category.DEFAULT" />
                <category android:name="android.intent.category.BROWSABLE" />
                <data android:scheme="sms" />
                <data android:scheme="smsto" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.VIEW" />
                <action android:name="android.intent.action.SENDTO" />
                <category android:name="android.intent.category.DEFAULT" />
                <category android:name="android.intent.category.BROWSABLE" />
                <data android:scheme="mms" />
                <data android:scheme="mmsto" />
            </intent-filter>
           <intent-filter>
               <action android:name="android.intent.action.SEND" />
               <category android:name="android.intent.category.DEFAULT" />
               <data android:mimeType="image/*" />
           </intent-filter>
           <intent-filter>
               <action android:name="android.intent.action.SEND" />
               <category android:name="android.intent.category.DEFAULT" />
               <data android:mimeType="video/*" />
           </intent-filter>
           <intent-filter>
               <action android:name="android.intent.action.SEND" />
               <category android:name="android.intent.category.DEFAULT" />
               <data android:mimeType="audio/*" />
           </intent-filter>
           <intent-filter>
               <action android:name="android.intent.action.SEND" />
               <category android:name="android.intent.category.DEFAULT" />
               <data android:mimeType="text/plain" />
           </intent-filter>
           <intent-filter>
               <action android:name="android.intent.action.SEND" />
               <category android:name="android.intent.category.DEFAULT" />
               <data android:mimeType="text/x-vcalendar" />
               <data android:mimeType="text/x-vCalendar" />
           </intent-filter>
           <intent-filter>
               <action android:name="android.intent.action.SEND_MULTIPLE" />
               <category android:name="android.intent.category.DEFAULT" />
               <data android:mimeType="image/*" />
           </intent-filter>
           <intent-filter>
               <action android:name="android.intent.action.SEND_MULTIPLE" />
               <category android:name="android.intent.category.DEFAULT" />
               <data android:mimeType="video/*" />
           </intent-filter>
           <intent-filter>
               <action android:name="android.intent.action.SEND_MULTIPLE" />
               <category android:name="android.intent.category.DEFAULT" />
               <data android:mimeType="audio/*" />
           </intent-filter>
           <intent-filter>
               <action android:name="android.intent.action.SENDMini" />
               <category android:name="android.intent.category.DEFAULT" />
               <data android:mimeType="image/*" />
           </intent-filter>
           <intent-filter>
               <action android:name="android.intent.action.SENDMini" />
               <category android:name="android.intent.category.DEFAULT" />
               <data android:mimeType="video/*" />
           </intent-filter>
           <intent-filter>
               <action android:name="android.intent.action.SENDMini" />
               <category android:name="android.intent.category.DEFAULT" />
               <data android:mimeType="audio/*" />
           </intent-filter>
           <intent-filter>
               <action android:name="android.intent.action.SENDMini" />
               <category android:name="android.intent.category.DEFAULT" />
               <data android:mimeType="text/plain" />
           </intent-filter>
           <intent-filter>
               <action android:name="android.intent.action.SEND_MULTIPLEMini" />
               <category android:name="android.intent.category.DEFAULT" />
               <data android:mimeType="*/*" />
           </intent-filter>
            <intent-filter>
           	   <action android:name="android.intent.action.SEND"/>
           	   <category android:name="android.intent.category.DEFAULT"></category>
           	   <data android:mimeType="application/ogg"/>
           </intent-filter>
        </activity>
                
        <activity android:name=".ui.MultiSaveActivity"
                  android:theme="@style/MultiSelectionHoloTheme"
                  android:configChanges="orientation|screenSize|keyboardHidden"
                  android:uiOptions="splitActionBarWhenNarrow">        
        </activity>

        <activity-alias android:name=".ui.SendMessageToActivity"
                  android:targetActivity=".ui.ComposeMessageActivity"
                  android:configChanges="orientation|screenSize|keyboardHidden|mcc|mnc"
                  android:windowSoftInputMode="stateHidden"
                  android:theme="@style/MmsHoloTheme" >
        </activity-alias>

        <activity-alias android:name=".ui.ForwardMessageActivity"
                  android:targetActivity=".ui.ComposeMessageActivity"
                  android:configChanges="orientation|screenSize|keyboardHidden|mcc|mnc"
                  android:windowSoftInputMode="stateHidden"
                  android:theme="@style/MmsHoloTheme" >
        </activity-alias>

        <activity android:name=".ui.DeliveryReportActivity"
            android:label="@string/delivery_report_activity"
            android:theme="@android:style/Theme.Holo.Light.Dialog">
        </activity>

        <activity android:name=".ui.WarnOfStorageLimitsActivity"
                android:theme="@android:style/Theme.Dialog"
                android:label="@string/storage_limits_activity"
                android:excludeFromRecents="true">
        </activity>

        <activity android:name=".ui.EditSlideDurationActivity"
            android:label="@string/change_duration_activity"
            android:theme="@android:style/Theme.Dialog">
        </activity>

        <activity android:name=".ui.SlideshowEditActivity"
        	android:configChanges="orientation|screenSize|keyboardHidden"
            android:theme="@style/MmsHoloTheme"
            android:label="@string/edit_slideshow_activity" />

        <activity android:name=".ui.SlideEditorActivity"
            android:windowSoftInputMode="adjustResize"
            android:theme="@style/MmsHoloTheme"
            android:configChanges="orientation|keyboardHidden"
            android:label="@string/edit_slide_activity" />

        <activity android:name=".ui.SlideshowActivity"
            android:noHistory="true"
            android:configChanges="orientation|screenSize|keyboardHidden"
            android:theme="@style/MmsHoloTheme"
            android:label="@string/slideshow_activity">
        </activity>

        <activity android:name=".ui.MmsPlayerActivity"
            android:configChanges="orientation|screenSize|keyboardHidden"
            android:theme="@style/MmsHoloTheme"
            android:label="@string/slideshow_activity">
        </activity>

        <activity android:name=".ui.ClassZeroActivity"
            android:label="@string/class_0_message_activity"
            android:theme="@android:style/Theme.Translucent"
            android:excludeFromRecents="true">
        </activity>

        <activity android:name=".ui.MessagingPreferenceActivity"
            android:theme="@style/MmsHoloTheme"
            android:configChanges="orientation|screenSize|keyboardHidden"
            android:label="@string/preferences_title" />
        <activity android:name=".ui.ImportSmsActivity"
            android:theme="@style/MmsHoloTheme"
            android:configChanges="orientation|screenSize|keyboardHidden"
            android:label="@string/pref_summary_import_msg" /> 

        <activity android:name=".ui.MultiSimPreferenceActivity"
            android:theme="@style/MmsHoloTheme"
            android:configChanges="orientation|screenSize|keyboardHidden"
            android:label="@string/preferences_title" />

        <activity android:name=".ui.SelectCardPreferenceActivity"
            android:theme="@style/MmsHoloTheme"
            android:configChanges="orientation|screenSize|keyboardHidden"
            android:label="@string/preferences_title" />
            
        <activity android:name=".ui.ShareVCardViaMMSActivity"
                  android:label="@string/mms"
                  android:theme="@android:style/Theme.NoTitleBar"
                  android:configChanges="orientation|keyboardHidden">        
             <intent-filter>
                 <action android:name="android.intent.action.SEND" />
                 <category android:name="android.intent.category.DEFAULT" />
                 <data android:mimeType="text/x-vCard" />
                 <data android:mimeType="text/x-vcard" />
             </intent-filter>
        </activity>
            
        <receiver android:name=".transaction.PushReceiver"
            android:permission="android.permission.BROADCAST_WAP_PUSH">
            <intent-filter>
                <action android:name="android.provider.Telephony.WAP_PUSH_RECEIVED" />
                <data android:mimeType="application/vnd.wap.mms-message" />
            </intent-filter>
        </receiver>

        <receiver android:name=".transaction.MmsSystemEventReceiver">
            <intent-filter>
                <action android:name="android.intent.action.CONTENT_CHANGED" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.BOOT_COMPLETED" />
                <action android:name="android.settings.AIRPLANE_MODE_SETTINGS" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.SIM_SETTING_INFO_CHANGED" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.ACTION_SHUTDOWN" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.DEVICE_STORAGE_FULL" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.DEVICE_STORAGE_NOT_FULL" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.LOCALE_CHANGED" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.SMS_DEFAULT_SIM" />
            </intent-filter>
        </receiver>

        <activity android:name=".ui.SmsTemplateEditActivity"
            android:configChanges="orientation|screenSize|keyboardHidden"
            android:theme="@style/MmsHoloTheme"
            android:label="@string/quick_text_editor" />


        <activity android:name=".ui.ManageSimMessages"
                  android:theme="@style/MmsHoloTheme"
                  android:launchMode="singleTop"
                  android:configChanges="orientation|screenSize|keyboardHidden"
                  android:label="@string/sim_manage_messages_title">
            <intent-filter>
                <action android:name="android.intent.action.VIEW" />
            </intent-filter>
        </activity>
        
        <activity android:name=".ui.MultiDeleteActivity"
                  android:theme="@style/MultiSelectionHoloTheme"
                  android:configChanges="orientation|screenSize|keyboardHidden"
                  android:uiOptions="splitActionBarWhenNarrow" />

        <!-- Require sender permissions to prevent SMS spoofing -->
        <receiver android:name=".transaction.PrivilegedSmsReceiver"
            android:permission="android.permission.BROADCAST_SMS">
            <intent-filter>
                <action android:name="android.provider.Telephony.SMS_RECEIVED" />
            </intent-filter>
        </receiver>

        <receiver android:name=".transaction.CBMessageReceiver"
            android:permission="android.permission.BROADCAST_SMS">
            <intent-filter>
                <action android:name="android.provider.Telephony.CB_SMS_RECEIVED" />
                <action android:name="android.provider.Telephony.SMS_CB_RECEIVED" />
                <action android:name="android.provider.Telephony.SMS_EMERGENCY_CB_RECEIVED" />
            </intent-filter>
        </receiver>

        <!-- Catch-all receiver for broadcasts that don't have associated security -->
        <receiver android:name=".transaction.SmsReceiver">
            <intent-filter>
                <action android:name="android.intent.action.BOOT_COMPLETED" />
            </intent-filter>
            <intent-filter>
                <action android:name="com.android.mms.transaction.MESSAGE_SENT" />
                <!-- TODO Do a better data match here. -->
                <data android:scheme="content" />
            </intent-filter>
            <intent-filter>
                <action android:name="android.intent.action.SEND_MESSAGE" />
            </intent-filter>
        </receiver>

        <receiver android:name=".transaction.WapPushReceiver">
            <intent-filter>
                <action android:name="android.intent.action.BOOT_COMPLETED" />
            </intent-filter>
            <intent-filter>
            <action android:name="android.provider.Telephony.WAP_PUSH_RECEIVED" />
            <data android:mimeType="application/vnd.wap.sic"/>
            <data android:mimeType="text/vnd.wap.si"/>

            <data android:mimeType="application/vnd.wap.slc"/>
            <data android:mimeType="text/vnd.wap.sl"/>

            <data android:mimeType="application/vnd.wap.coc"/>
            <data android:mimeType="text/vnd.wap.co"/>            
            </intent-filter>
        </receiver>

        <receiver android:name=".transaction.WapPushTimeChangedReceiver">
            <intent-filter>
                <action android:name="android.intent.action.TIME_SET" />
                <action android:name="android.intent.action.DATE_CHANGED" />
            </intent-filter>
        </receiver>

        <receiver android:name=".util.OMACPReceiver">
            <intent-filter>
                <action android:name="com.mediatek.omacp.settings"/>
                <data android:mimeType="application/com.mediatek.omacp-w4" />
                <data android:mimeType="application/com.mediatek.omacp-ap0005" />
            </intent-filter>
            <intent-filter>
                <action android:name="com.mediatek.omacp.capability"/>
            </intent-filter>
        </receiver>

        <receiver android:name=".transaction.MessageStatusReceiver">
            <intent-filter>
                <action android:name="com.android.mms.transaction.MessageStatusReceiver.MESSAGE_STATUS_RECEIVED" />
            </intent-filter>
            <intent-filter>
                <action android:name="MMS_READ_STATE_CHANGE" />
            </intent-filter>
        </receiver>

        <receiver android:name=".transaction.SimFullReceiver">
            <intent-filter>
                <action android:name="android.provider.Telephony.SIM_FULL" />
            </intent-filter>
        </receiver>

        <receiver android:name=".transaction.SmsRejectedReceiver">
            <intent-filter>
                <action android:name="android.provider.Telephony.SMS_REJECTED" />
            </intent-filter>
        </receiver>

        <activity android:name=".ui.ConfirmRateLimitActivity"
                  android:theme="@android:style/Theme.Dialog">
            <intent-filter>
                <action android:name="com.android.mms.RATE_LIMIT_SURPASSED" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <activity android:name=".ui.SearchActivity"
            android:theme="@style/MmsHoloTheme"
            android:label="@string/search"
            android:launchMode="singleTask"
            android:configChanges="orientation|screenSize|keyboardHidden" >
            <intent-filter>
                <action android:name="android.intent.action.SEARCH" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
            <meta-data android:name="android.app.searchable"
                android:resource="@xml/searchable" />
        </activity>

        <meta-data android:name="android.app.default_searchable"
            android:value=".ui.SearchActivity" />

        <!-- Search Suggestions Provider -->
        <provider android:name="SuggestionsProvider"
            android:readPermission="android.permission.READ_SMS"
            android:authorities="com.android.mms.SuggestionsProvider" >
            <path-permission
                    android:pathPrefix="/search_suggest_query"
                    android:readPermission="android.permission.GLOBAL_SEARCH" />
            <path-permission
                    android:pathPrefix="/search_suggest_shortcut"
                    android:readPermission="android.permission.GLOBAL_SEARCH" />
        </provider>

        <service android:name=".ui.NoConfirmationSendService"
                 android:permission="android.permission.SEND_SMS_NO_CONFIRMATION"
                 android:exported="true" >
            <intent-filter>
                <action android:name="com.android.mms.intent.action.SENDTO_NO_CONFIRMATION" />
                <category android:name="android.intent.category.DEFAULT" />
                <data android:scheme="sms" />
                <data android:scheme="smsto" />
            </intent-filter>
        </service>

        <provider android:name="TempFileProvider"
                  android:authorities="mms_temp_file"
                  android:multiprocess="true" />

        <activity android:name=".ui.MiniPreferenceActivity" >
            <intent-filter>
                <action android:name="com.android.mms.intent.action.MESSAGING_APP_NOTIFICATIONS" />
                <category android:name="android.intent.category.DEFAULT" />
            </intent-filter>
        </activity>

        <activity android:name=".ui.LongPressGuideLineActivity"
            android:theme="@android:style/Theme.NoTitleBar" 
            android:screenOrientation="portrait"
            android:configChanges="orientation|screenSize|keyboardHidden">
        </activity>    
            

    </application>
</manifest>
